/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef CSCHEMEVIEWER_H
#define CSCHEMEVIEWER_H


#include "cviewer.h"

#include <QScrollArea>

class CViewPortWatcher;


class CScrollArea:public QScrollArea
{
  Q_OBJECT

protected:
  void wheelEvent(QWheelEvent *e);
  void resizeEvent(QResizeEvent * event);

signals:
  void sizeChanged();
};



class CSchemeViewer:public CViewer
{
 Q_OBJECT

 public:
   CSchemeViewer(View* schm,QWidget *parent=0);
   virtual ~CSchemeViewer();
   void reset();
   virtual QImage image() const {return scheme->toImage(true);}
   virtual CViewPortWatcher *viewPortWatcher() const {return ViewPortWatcher;}

 private:
   CScrollArea* scrollArea;
   View* scheme;
   CViewPortWatcher *ViewPortWatcher;
};


#endif // CSCHEMEVIEWER_H
